Index: uspace/lib/ui/src/ui.c
===================================================================
--- uspace/lib/ui/src/ui.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/ui.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -39,6 +39,4 @@
 #include <errno.h>
 #include <fibril.h>
-#include <gfx/color.h>
-#include <gfx/render.h>
 #include <io/console.h>
 #include <stdbool.h>
@@ -55,6 +53,6 @@
  *
  * Output specification has the form <proto>@<service> where proto is
- * eiher 'disp' for display service, 'cons' for console, 'null'
- * for dummy output. Service is a location ID service name (e.g. hid/display).
+ * eiher 'disp' for display service or 'cons' for console. Service
+ * is a location ID service name (e.g. hid/display).
  *
  * @param ospec Output specification
@@ -82,6 +80,4 @@
 		} else if (str_lcmp(ospec, "cons@", str_length("cons@")) == 0) {
 			*ws = ui_ws_console;
-		} else if (str_lcmp(ospec, "null@", str_length("null@")) == 0) {
-			*ws = ui_ws_null;
 		} else {
 			*ws = ui_ws_unknown;
@@ -101,7 +97,5 @@
  *
  * @param ospec Output specification or @c UI_DISPLAY_DEFAULT to use
- *              the default display service, UI_CONSOLE_DEFAULT to use
- *		the default console service, UI_DISPLAY_NULL to use
- *		dummy output.
+ *              the default output
  * @param rui Place to store pointer to new UI
  * @return EOK on success or an error code
@@ -115,6 +109,4 @@
 	ui_winsys_t ws;
 	const char *osvc;
-	sysarg_t cols;
-	sysarg_t rows;
 	ui_t *ui;
 
@@ -135,12 +127,4 @@
 		if (console == NULL)
 			return EIO;
-
-		rc = console_get_size(console, &cols, &rows);
-		if (rc != EOK) {
-			console_done(console);
-			return rc;
-		}
-
-		console_cursor_visibility(console, false);
 
 		/* ws == ui_ws_console */
@@ -159,14 +143,4 @@
 
 		ui->cgc = cgc;
-		ui->rect.p0.x = 0;
-		ui->rect.p0.y = 0;
-		ui->rect.p1.x = cols;
-		ui->rect.p1.y = rows;
-
-		(void) ui_paint(ui);
-	} else if (ws == ui_ws_null) {
-		rc = ui_create_disp(NULL, &ui);
-		if (rc != EOK)
-			return rc;
 	} else {
 		return EINVAL;
@@ -229,8 +203,6 @@
 		if (ui->cgc != NULL)
 			console_gc_delete(ui->cgc);
-		if (ui->console != NULL) {
-			console_cursor_visibility(ui->console, true);
+		if (ui->console != NULL)
 			console_done(ui->console);
-		}
 		if (ui->display != NULL)
 			display_close(ui->display);
@@ -244,5 +216,4 @@
 	ui_window_t *awnd;
 	ui_evclaim_t claim;
-	pos_event_t pos;
 
 	awnd = ui_window_get_active(ui);
@@ -255,14 +226,8 @@
 		break;
 	case CEV_POS:
-		pos = event->ev.pos;
-		/* Translate event to window-relative coordinates */
-		pos.hpos -= awnd->dpos.x;
-		pos.vpos -= awnd->dpos.y;
-
-		claim = ui_wdecor_pos_event(awnd->wdecor, &pos);
+		claim = ui_wdecor_pos_event(awnd->wdecor, &event->ev.pos);
 		/* Note: If event is claimed, awnd might not be valid anymore */
 		if (claim == ui_unclaimed)
-			ui_window_send_pos(awnd, &pos);
-
+			ui_window_send_pos(awnd, &event->ev.pos);
 		break;
 	}
@@ -315,31 +280,5 @@
 {
 	errno_t rc;
-	gfx_context_t *gc;
 	ui_window_t *awnd;
-	gfx_color_t *color = NULL;
-
-	/* In case of null output */
-	if (ui->cgc == NULL)
-		return EOK;
-
-	gc = console_gc_get_ctx(ui->cgc);
-
-	rc = gfx_color_new_ega(0x11, &color);
-	if (rc != EOK)
-		return rc;
-
-	rc = gfx_set_color(gc, color);
-	if (rc != EOK) {
-		gfx_color_delete(color);
-		return rc;
-	}
-
-	rc = gfx_fill_rect(gc, &ui->rect);
-	if (rc != EOK) {
-		gfx_color_delete(color);
-		return rc;
-	}
-
-	gfx_color_delete(color);
 
 	/* XXX Should repaint all windows */
Index: uspace/lib/ui/src/wdecor.c
===================================================================
--- uspace/lib/ui/src/wdecor.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/wdecor.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -61,4 +61,5 @@
 	wdecor_edge_h = 4,
 	wdecor_tbar_h = 22,
+	wdecor_tbar_h_text = 1,
 	wdecor_frame_w = 4,
 	wdecor_frame_w_text = 1
@@ -169,5 +170,4 @@
 	gfx_rect_t rect;
 	gfx_rect_t trect;
-	gfx_rect_t text_rect;
 	gfx_text_fmt_t fmt;
 	gfx_coord2_t pos;
@@ -180,6 +180,7 @@
 
 		if (wdecor->res->textmode != false) {
-			rc = ui_paint_text_box(wdecor->res, &rect,
-			    ui_box_double, wdecor->res->wnd_face_color);
+			rc = ui_paint_bevel(wdecor->res->gc, &rect,
+			    wdecor->res->wnd_frame_hi_color,
+			    wdecor->res->wnd_frame_sh_color, 1, &rect);
 			if (rc != EOK)
 				return rc;
@@ -207,15 +208,15 @@
 			if (rc != EOK)
 				return rc;
-
-			rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
-			    wdecor->res->tbar_act_bg_color :
-			    wdecor->res->tbar_inact_bg_color);
-			if (rc != EOK)
-				return rc;
-
-			rc = gfx_fill_rect(wdecor->res->gc, &trect);
-			if (rc != EOK)
-				return rc;
 		}
+
+		rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
+		    wdecor->res->tbar_act_bg_color :
+		    wdecor->res->tbar_inact_bg_color);
+		if (rc != EOK)
+			return rc;
+
+		rc = gfx_fill_rect(wdecor->res->gc, &trect);
+		if (rc != EOK)
+			return rc;
 
 		gfx_text_fmt_init(&fmt);
@@ -229,26 +230,4 @@
 		pos.y = (trect.p0.y + trect.p1.y) / 2;
 
-		if (wdecor->res->textmode) {
-			/* Make space around caption text */
-			gfx_text_rect(wdecor->res->font, &pos, &fmt,
-			    wdecor->caption, &text_rect);
-
-			/* Only make space if caption is non-empty */
-			if (text_rect.p0.x < text_rect.p1.x) {
-				text_rect.p0.x -= 1;
-				text_rect.p1.x += 1;
-			}
-
-			rc = gfx_set_color(wdecor->res->gc, wdecor->active ?
-			    wdecor->res->tbar_act_bg_color :
-			    wdecor->res->tbar_inact_bg_color);
-			if (rc != EOK)
-				return rc;
-
-			rc = gfx_fill_rect(wdecor->res->gc, &text_rect);
-			if (rc != EOK)
-				return rc;
-		}
-
 		rc = gfx_puttext(wdecor->res->font, &pos, &fmt, wdecor->caption);
 		if (rc != EOK)
@@ -322,4 +301,5 @@
 {
 	gfx_coord_t frame_w;
+	gfx_coord_t tbar_h;
 
 	/* Does window have a frame? */
@@ -338,14 +318,10 @@
 	/* Does window have a title bar? */
 	if ((wdecor->style & ui_wds_titlebar) != 0) {
-		if (wdecor->res->textmode) {
-			geom->title_bar_rect.p0 = wdecor->rect.p0;
-			geom->title_bar_rect.p1.x = wdecor->rect.p1.x;
-			geom->title_bar_rect.p1.y = wdecor->rect.p0.y + 1;
-		} else {
-			geom->title_bar_rect.p0 = geom->interior_rect.p0;
-			geom->title_bar_rect.p1.x = geom->interior_rect.p1.x;
-			geom->title_bar_rect.p1.y = geom->interior_rect.p0.y +
-			    wdecor_tbar_h;
-		}
+		tbar_h = wdecor->res->textmode ?
+		    wdecor_tbar_h_text : wdecor_tbar_h;
+
+		geom->title_bar_rect.p0 = geom->interior_rect.p0;
+		geom->title_bar_rect.p1.x = geom->interior_rect.p1.x;
+		geom->title_bar_rect.p1.y = geom->interior_rect.p0.y + tbar_h;
 
 		geom->app_area_rect.p0.x = geom->interior_rect.p0.x;
Index: uspace/lib/ui/src/window.c
===================================================================
--- uspace/lib/ui/src/window.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/src/window.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -39,5 +39,4 @@
 #include <gfx/bitmap.h>
 #include <gfx/context.h>
-#include <gfx/cursor.h>
 #include <gfx/render.h>
 #include <io/kbd_event.h>
@@ -89,26 +88,6 @@
 static void ui_window_invalidate(void *, gfx_rect_t *);
 static void ui_window_update(void *);
-static errno_t ui_window_cursor_get_pos(void *, gfx_coord2_t *);
-static errno_t ui_window_cursor_set_pos(void *, gfx_coord2_t *);
-static errno_t ui_window_cursor_set_visible(void *, bool);
-
-/** Window memory GC callbacks */
-static mem_gc_cb_t ui_window_mem_gc_cb = {
-	.invalidate = ui_window_invalidate,
-	.update = ui_window_update,
-	.cursor_get_pos = ui_window_cursor_get_pos,
-	.cursor_set_pos = ui_window_cursor_set_pos,
-	.cursor_set_visible = ui_window_cursor_set_visible
-};
-
 static void ui_window_app_invalidate(void *, gfx_rect_t *);
 static void ui_window_app_update(void *);
-
-/** Application area memory GC callbacks */
-static mem_gc_cb_t ui_window_app_mem_gc_cb = {
-	.invalidate = ui_window_app_invalidate,
-	.update = ui_window_app_update
-};
-
 static void ui_window_expose_cb(void *);
 
@@ -132,19 +111,16 @@
 /** Compute where window should be placed on the screen.
  *
- * This only applies to windows that do not use default placement or
- * if we are running in full-screen mode.
- *
- * @param window Window
- * @param drect Display rectangle
+ * This only applies to windows that do not use default placement.
+ *
+ * @param window Window
+ * @param display Display
+ * @param info Display info
  * @param params Window parameters
  * @param pos Place to store position of top-left corner
  */
-static void ui_window_place(ui_window_t *window, gfx_rect_t *drect,
-    ui_wnd_params_t *params, gfx_coord2_t *pos)
-{
-	gfx_coord2_t dims;
-
-	assert(params->placement != ui_wnd_place_default ||
-	    ui_is_fullscreen(window->ui));
+static void ui_window_place(ui_window_t *window, display_t *display,
+    display_info_t *info, ui_wnd_params_t *params, gfx_coord2_t *pos)
+{
+	assert(params->placement != ui_wnd_place_default);
 
 	pos->x = 0;
@@ -153,26 +129,21 @@
 	switch (params->placement) {
 	case ui_wnd_place_default:
-		assert(ui_is_fullscreen(window->ui));
-		/* Center window */
-		gfx_rect_dims(&params->rect, &dims);
-		pos->x = (drect->p0.x + drect->p1.x) / 2 - dims.x / 2;
-		pos->y = (drect->p0.y + drect->p1.y) / 2 - dims.y / 2;
-		break;
+		assert(false);
 	case ui_wnd_place_top_left:
 	case ui_wnd_place_full_screen:
-		pos->x = drect->p0.x - params->rect.p0.x;
-		pos->y = drect->p0.y - params->rect.p0.y;
+		pos->x = info->rect.p0.x - params->rect.p0.x;
+		pos->y = info->rect.p0.y - params->rect.p0.y;
 		break;
 	case ui_wnd_place_top_right:
-		pos->x = drect->p1.x - params->rect.p1.x;
-		pos->y = drect->p0.y - params->rect.p0.y;
+		pos->x = info->rect.p1.x - params->rect.p1.x;
+		pos->y = info->rect.p0.y - params->rect.p0.y;
 		break;
 	case ui_wnd_place_bottom_left:
-		pos->x = drect->p0.x - params->rect.p0.x;
-		pos->y = drect->p1.y - params->rect.p1.y;
+		pos->x = info->rect.p0.x - params->rect.p0.x;
+		pos->y = info->rect.p1.y - params->rect.p1.y;
 		break;
 	case ui_wnd_place_bottom_right:
-		pos->x = drect->p1.x - params->rect.p1.x;
-		pos->y = drect->p1.y - params->rect.p1.y;
+		pos->x = info->rect.p1.x - params->rect.p1.x;
+		pos->y = info->rect.p1.y - params->rect.p1.y;
 		break;
 	case ui_wnd_place_popup:
@@ -205,7 +176,5 @@
 	gfx_bitmap_alloc_t alloc;
 	gfx_bitmap_t *bmp = NULL;
-	gfx_coord2_t off;
 	mem_gc_t *memgc = NULL;
-	xlate_gc_t *xgc = NULL;
 	errno_t rc;
 
@@ -213,6 +182,4 @@
 	if (window == NULL)
 		return ENOMEM;
-
-	window->ui = ui;
 
 	display_wnd_params_init(&dparams);
@@ -240,6 +207,6 @@
 		if (params->placement != ui_wnd_place_default) {
 			/* Set initial display window position */
-			ui_window_place(window, &info.rect, params,
-			    &dparams.pos);
+			ui_window_place(window, ui->display, &info,
+			    params, &dparams.pos);
 
 			dparams.flags |= wndf_setpos;
@@ -256,11 +223,4 @@
 	} else if (ui->console != NULL) {
 		gc = console_gc_get_ctx(ui->cgc);
-
-		if (params->placement == ui_wnd_place_full_screen) {
-			/* Make window the size of the screen */
-			gfx_rect_dims(&ui->rect, &scr_dims);
-			gfx_coord2_add(&dparams.rect.p0, &scr_dims,
-			    &dparams.rect.p1);
-		}
 	} else {
 		/* Needed for unit tests */
@@ -282,5 +242,5 @@
 
 	/* Move rectangle so that top-left corner is 0,0 */
-	gfx_rect_rtranslate(&dparams.rect.p0, &dparams.rect, &bparams.rect);
+	gfx_rect_rtranslate(&params->rect.p0, &params->rect, &bparams.rect);
 
 	rc = gfx_bitmap_create(gc, &bparams, NULL, &bmp);
@@ -295,6 +255,6 @@
 	}
 
-	rc = mem_gc_create(&bparams.rect, &alloc, &ui_window_mem_gc_cb,
-	    (void *) window, &memgc);
+	rc = mem_gc_create(&bparams.rect, &alloc, ui_window_invalidate,
+	    ui_window_update, (void *) window, &memgc);
 	if (rc != EOK) {
 		gfx_bitmap_destroy(window->app_bmp);
@@ -306,34 +266,11 @@
 	window->gc = mem_gc_get_ctx(memgc);
 	window->realgc = gc;
-	(void) off;
 #else
-	/* Server-side rendering */
-
-	/* Full-screen mode? */
-	if (ui->display == NULL) {
-		/* Create translating GC to translate window contents */
-		off.x = 0;
-		off.y = 0;
-		rc = xlate_gc_create(&off, gc, &xgc);
-		if (rc != EOK)
-			goto error;
-
-		window->xgc = xgc;
-		window->gc = xlate_gc_get_ctx(xgc);
-		window->realgc = gc;
-	} else {
-		window->gc = gc;
-	}
-
-	(void) ui_window_mem_gc_cb;
+	(void) ui_window_update;
+	(void) ui_window_invalidate;
 	(void) alloc;
 	(void) bparams;
+	window->gc = gc;
 #endif
-	if (ui->display == NULL) {
-		ui_window_place(window, &ui->rect, params, &window->dpos);
-
-		if (window->xgc != NULL)
-			xlate_gc_set_off(window->xgc, &window->dpos);
-	}
 
 	rc = ui_resource_create(window->gc, ui_is_textmode(ui), &res);
@@ -351,5 +288,7 @@
 	ui_resource_set_expose_cb(res, ui_window_expose_cb, (void *) window);
 
+	window->ui = ui;
 	window->rect = dparams.rect;
+
 	window->res = res;
 	window->wdecor = wdecor;
@@ -366,6 +305,4 @@
 	if (memgc != NULL)
 		mem_gc_delete(memgc);
-	if (xgc != NULL)
-		xlate_gc_delete(xgc);
 	if (bmp != NULL)
 		gfx_bitmap_destroy(bmp);
@@ -403,4 +340,5 @@
 	if (window->bmp != NULL)
 		gfx_bitmap_destroy(window->bmp);
+	gfx_context_delete(window->gc);
 	if (window->dwindow != NULL)
 		display_window_destroy(window->dwindow);
@@ -601,14 +539,4 @@
 }
 
-/** Get window's containing UI.
- *
- * @param window Window
- * @return Containing UI
- */
-ui_t *ui_window_get_ui(ui_window_t *window)
-{
-	return window->ui;
-}
-
 /** Get UI resource from window.
  *
@@ -646,5 +574,6 @@
 			return rc;
 	} else {
-		*pos = window->dpos;
+		pos->x = 0;
+		pos->y = 0;
 	}
 
@@ -689,6 +618,6 @@
 		}
 
-		rc = mem_gc_create(&params.rect, &alloc,
-		    &ui_window_app_mem_gc_cb, (void *) window, &memgc);
+		rc = mem_gc_create(&params.rect, &alloc, ui_window_app_invalidate,
+		    ui_window_app_update, (void *) window, &memgc);
 		if (rc != EOK) {
 			gfx_bitmap_destroy(window->app_bmp);
@@ -942,6 +871,4 @@
 	if (window->cb != NULL && window->cb->kbd != NULL)
 		window->cb->kbd(window, window->arg, kbd);
-	else
-		return ui_window_def_kbd(window, kbd);
 }
 
@@ -982,14 +909,4 @@
 }
 
-/** Default window keyboard event routine.
- *
- * @param window Window
- */
-void ui_window_def_kbd(ui_window_t *window, kbd_event_t *kbd)
-{
-	if (window->control != NULL)
-		ui_control_kbd_event(window->control, kbd);
-}
-
 /** Default window paint routine.
  *
@@ -1065,8 +982,6 @@
 	ui_window_t *window = (ui_window_t *) arg;
 
-	if (!gfx_rect_is_empty(&window->dirty_rect)) {
-		(void) gfx_bitmap_render(window->bmp, &window->dirty_rect,
-		    &window->dpos);
-	}
+	if (!gfx_rect_is_empty(&window->dirty_rect))
+		(void) gfx_bitmap_render(window->bmp, &window->dirty_rect, NULL);
 
 	window->dirty_rect.p0.x = 0;
@@ -1074,52 +989,4 @@
 	window->dirty_rect.p1.x = 0;
 	window->dirty_rect.p1.y = 0;
-}
-
-/** Window cursor get position callback
- *
- * @param arg Argument (ui_window_t *)
- * @param pos Place to store position
- */
-static errno_t ui_window_cursor_get_pos(void *arg, gfx_coord2_t *pos)
-{
-	ui_window_t *window = (ui_window_t *) arg;
-	gfx_coord2_t cpos;
-	errno_t rc;
-
-	rc = gfx_cursor_get_pos(window->realgc, &cpos);
-	if (rc != EOK)
-		return rc;
-
-	pos->x = cpos.x - window->dpos.x;
-	pos->y = cpos.y - window->dpos.y;
-	return EOK;
-}
-
-/** Window cursor set position callback
- *
- * @param arg Argument (ui_window_t *)
- * @param pos New position
- */
-static errno_t ui_window_cursor_set_pos(void *arg, gfx_coord2_t *pos)
-{
-	ui_window_t *window = (ui_window_t *) arg;
-	gfx_coord2_t cpos;
-
-	cpos.x = pos->x + window->dpos.x;
-	cpos.y = pos->y + window->dpos.y;
-
-	return gfx_cursor_set_pos(window->realgc, &cpos);
-}
-
-/** Window cursor set visibility callback
- *
- * @param arg Argument (ui_window_t *)
- * @param visible @c true iff cursor is to be made visible
- */
-static errno_t ui_window_cursor_set_visible(void *arg, bool visible)
-{
-	ui_window_t *window = (ui_window_t *) arg;
-
-	return gfx_cursor_set_visible(window->realgc, visible);
 }
 
Index: uspace/lib/ui/test/checkbox.c
===================================================================
--- uspace/lib/ui/test/checkbox.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/checkbox.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -151,6 +151,6 @@
 }
 
-/** Paint check box in graphics mode */
-PCUT_TEST(paint_gfx)
+/** Paint check box */
+PCUT_TEST(paint)
 {
 	errno_t rc;
@@ -171,35 +171,5 @@
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
-	rc = ui_checkbox_paint_gfx(checkbox);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	ui_checkbox_destroy(checkbox);
-	ui_resource_destroy(resource);
-
-	rc = gfx_context_delete(gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-}
-
-/** Paint check box in text mode */
-PCUT_TEST(paint_text)
-{
-	errno_t rc;
-	gfx_context_t *gc = NULL;
-	test_gc_t tgc;
-	ui_resource_t *resource = NULL;
-	ui_checkbox_t *checkbox;
-
-	memset(&tgc, 0, sizeof(tgc));
-	rc = gfx_context_new(&ops, &tgc, &gc);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = ui_resource_create(gc, false, &resource);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(resource);
-
-	rc = ui_checkbox_create(resource, "Hello", &checkbox);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-
-	rc = ui_checkbox_paint_text(checkbox);
+	rc = ui_checkbox_paint(checkbox);
 	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
 
Index: uspace/lib/ui/test/control.c
===================================================================
--- uspace/lib/ui/test/control.c	(revision 8a9a41e01a710f4ef36a33613b89d0973f674280)
+++ uspace/lib/ui/test/control.c	(revision 2ce943a86a6fbca13a3d2809d0aa9d9dcd1cf398)
@@ -1,4 +1,4 @@
 /*
- * Copyright (c) 2021 Jiri Svoboda
+ * Copyright (c) 2020 Jiri Svoboda
  * All rights reserved.
  *
@@ -29,5 +29,4 @@
 #include <errno.h>
 #include <mem.h>
-#include <io/kbd_event.h>
 #include <io/pos_event.h>
 #include <pcut/pcut.h>
@@ -42,5 +41,4 @@
 static void test_ctl_destroy(void *);
 static errno_t test_ctl_paint(void *);
-static ui_evclaim_t test_ctl_kbd_event(void *, kbd_event_t *);
 static ui_evclaim_t test_ctl_pos_event(void *, pos_event_t *);
 static void test_ctl_unfocus(void *);
@@ -49,5 +47,4 @@
 	.destroy = test_ctl_destroy,
 	.paint = test_ctl_paint,
-	.kbd_event = test_ctl_kbd_event,
 	.pos_event = test_ctl_pos_event,
 	.unfocus = test_ctl_unfocus
@@ -67,9 +64,4 @@
 	bool paint;
 
-	/** @c true iff kbd_event was called */
-	bool kbd;
-	/** Keyboard event that was sent */
-	kbd_event_t kevent;
-
 	/** @c true iff pos_event was called */
 	bool pos;
@@ -142,35 +134,4 @@
 	PCUT_ASSERT_ERRNO_VAL(resp.rc, rc);
 	PCUT_ASSERT_TRUE(resp.paint);
-
-	ui_control_delete(control);
-}
-
-/** Test sending keyboard event to control */
-PCUT_TEST(kbd_event)
-{
-	ui_control_t *control = NULL;
-	test_resp_t resp;
-	kbd_event_t event;
-	ui_evclaim_t claim;
-	errno_t rc;
-
-	rc = ui_control_new(&test_ctl_ops, &resp, &control);
-	PCUT_ASSERT_ERRNO_VAL(EOK, rc);
-	PCUT_ASSERT_NOT_NULL(control);
-
-	resp.claim = ui_claimed;
-	resp.kbd = false;
-	event.type = KEY_PRESS;
-	event.key = KC_2;
-	event.mods = KM_LSHIFT;
-	event.c = '@';
-
-	claim = ui_control_kbd_event(control, &event);
-	PCUT_ASSERT_EQUALS(resp.claim, claim);
-	PCUT_ASSERT_TRUE(resp.kbd);
-	PCUT_ASSERT_EQUALS(resp.kevent.type, event.type);
-	PCUT_ASSERT_INT_EQUALS(resp.kevent.key, event.key);
-	PCUT_ASSERT_INT_EQUALS(resp.kevent.mods, event.mods);
-	PCUT_ASSERT_INT_EQUALS(resp.kevent.c, event.c);
 
 	ui_control_delete(control);
@@ -244,14 +205,4 @@
 }
 
-static ui_evclaim_t test_ctl_kbd_event(void *arg, kbd_event_t *event)
-{
-	test_resp_t *resp = (test_resp_t *) arg;
-
-	resp->kbd = true;
-	resp->kevent = *event;
-
-	return resp->claim;
-}
-
 static ui_evclaim_t test_ctl_pos_event(void *arg, pos_event_t *event)
 {
